// CS 106 Winter 2018 Lab 01
// Your Name
// Your Student ID #

// The number of points on each side of the sqaure
int PTS_PER_SIDE = 25;
// A convenient shorthand for the total number of points
int TOTAL_PTS = 4 * PTS_PER_SIDE;
// The width of the margin around the border of the sketch
// window.
float MARGIN = 50;

// Two arrays to hold the X and Y coordinates of a set of
// points.  The string art design will connnect these points.
float[] xs;
float[] ys;

void setup()
{
  size( 500, 500 );
  initPoints();
}

void draw()
{   
  background( 255 );

  // Draw a dot at each point location.
  fill( 0 );
  noStroke();
  for ( int idx = 0; idx < TOTAL_PTS; ++idx ) {
    ellipse( xs[idx], ys[idx], 5, 5 );
  }
}

void initPoints()
{
  // Create two arrays of the right sizes.
  xs = new float[TOTAL_PTS];
  ys = new float[TOTAL_PTS];

  for ( int idx = 0; idx < PTS_PER_SIDE; ++idx ) {
    // Points along the top edge, from left to right
    xs[idx] = map( idx, 0, PTS_PER_SIDE, MARGIN, width - MARGIN );
    ys[idx] = MARGIN;

    // Points along the right edge, from top to bottom
    xs[idx+PTS_PER_SIDE] = width - MARGIN;
    ys[idx+PTS_PER_SIDE] = map( idx, 0, PTS_PER_SIDE, MARGIN, height - MARGIN );

    // Points along the bottom edge, from right to left
    xs[idx+2*PTS_PER_SIDE] = map( idx, 0, PTS_PER_SIDE, width - MARGIN, MARGIN );
    ys[idx+2*PTS_PER_SIDE] = height - MARGIN;

    // Points along the left edge, from bottom to top
    xs[idx+3*PTS_PER_SIDE] = MARGIN;
    ys[idx+3*PTS_PER_SIDE] = map( idx, 0, PTS_PER_SIDE, height - MARGIN, MARGIN );
  }
}